<template>
  <div data-aos="fade" class="cart-page">
    <div class="section">
      <div class="container-fluid">
        <div class="wrapper">
          <h2 class="h2 bottom-green-line section__header">Oferta</h2>
          <div class="shop-header bottom-silver-line">
            <div class="breadcrumbs"><a :href="links.home_url" title="Strona główna">Strona główna</a><span class="slash">/</span>
              <a :href="`${links.shop_url}?tab=2`" title="Dla bliskich">Dla bliskich</a><span class="d-none d-md-inline-flex"><span class="slash">/</span>Koszyk</span>
            </div>
            <a :href="links.cart_url" class="cart" title="Koszyk">
              <svg id="Group_5070" data-name="Group 5070" xmlns="http://www.w3.org/2000/svg" width="26.45" height="23"
                   viewBox="0 0 26.45 23">
                <path id="Path_4928" data-name="Path 4928"
                      d="M4.862,10a.863.863,0,0,0,0,1.725H8.3c1.427,3.535,2.834,7.077,4.25,10.62l-1.3,3.135a.863.863,0,0,0,.8,1.195H26.425a.863.863,0,1,0,0-1.725H13.344l.746-1.779,13.845-1.105a.887.887,0,0,0,.773-.665l1.725-7.475a.9.9,0,0,0-.845-1.051H10.622l-.934-2.336a.884.884,0,0,0-.8-.539Zm6.451,4.6H28.5l-1.339,5.8L14.054,21.446Zm3.612,12.65A2.875,2.875,0,1,0,17.8,30.125,2.888,2.888,0,0,0,14.925,27.25Zm8.625,0a2.875,2.875,0,1,0,2.875,2.875A2.888,2.888,0,0,0,23.55,27.25Zm-8.625,1.725a1.15,1.15,0,1,1-1.15,1.15A1.137,1.137,0,0,1,14.925,28.975Zm8.625,0a1.15,1.15,0,1,1-1.15,1.15A1.137,1.137,0,0,1,23.55,28.975Z"
                      transform="translate(-4 -10)" fill="#8bc549"/>
              </svg>
              Koszyk (<span class="js-count-cart-products">{{ data.products.length }}</span>)
            </a>
          </div>
          <div class="section__content">
            <h1 class="h2 section__title">
              Koszyk
            </h1>
            <template v-if="cart.products && cart.products.length">
              <div class="c-table">
                <div class="thead">
                  <div>Product</div>
                  <div>Ilość</div>
                  <div>Cena</div>
                  <div>&nbsp;</div>
                </div>
                <div class="tbody">
                  <div class="c-product" v-for="product in cart.products">
                    <div class="c-product__image-mobile">
                      <img v-if="product.image" :src="product.image" :alt="product.name" :title="product.name">
                    </div>
                    <div class="c-product__content">
                      <div>
                        <img v-if="product.image" class="c-product__image" :src="product.image" :alt="product.name" :title="product.name">
                        <div class="d-flex flex-column">
                          <div class="c-product__desc">Produkt</div>
                          <a :href="`${product.url}?offer=friends`" class="c-product__name" :title="product.name" v-html="product.name"></a>
                          <div v-if="product.variation" class="c-product__time">
                            Kupon <span v-if="product.attributes.attribute_pa_pakage === `five`">5x</span> {{ product.variation.Czas }}
                          </div>
                        </div>
                      </div>
                      <div>
                        <div class="c-product__desc">Ilość</div>
                        <div class="counter">
                          <div class="counter__minus" @click="setCount(parseInt(product.quantity) - 1, false, product)">
                            -
                          </div>
                          <div class="counter__number">
                            {{ product.quantity }}
                          </div>
                          <div class="counter__plus" @click="setCount(parseInt(product.quantity) + 1, true, product)">
                            +
                          </div>
                        </div>
                      </div>
                      <div>
                        <div class="c-product__desc">Cena</div>
                        <div class="c-product__price">
                          {{ product.price }} {{ data.currency }}
                        </div>
                      </div>
                      <div @click="$store.dispatch('AJAX_REMOVE_FROM_CART', product.key)" class="c-product__remove">
                        Usuń z koszyka
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="section__bottom">
                <div class="coupon">
                  <div class="d-flex align-items-center" v-if="cart.code">
                    <div class="coupon__code">Kupon: <span>{{ cart.code }}</span></div>
                    <div class="coupon__remove"
                         @click="$store.dispatch('REMOVE_COUPON_CODE', {coupon: couponValue}); couponValue = ''">
                      Usuń
                    </div>
                  </div>
                  <div v-else>
                    <label class="coupon__label">Kod rabatowy <span>(opcjonalnie)</span></label>
                    <div class="coupon__content">
                      <input
                        type="text"
                        class="coupon__input input"
                        :class="{'input-error': couponErrorText}"
                        v-model="couponValue"
                        placeholder="Kod rabatowy"
                      >
                      <button class="button button--green button--green--outline coupon__button"
                              @click="addCouponCode">
                        Zastosuj
                      </button>
                    </div>
                  </div>
                  <div v-if="couponErrorText" class="coupon__error">
                    {{ couponErrorText }}
                  </div>
                </div>
                <div class="summary">
                  <h5 class="h3 summary__title">Do zapłaty</h5>
                  <div class="summary__item">
                    <span>Suma</span>
                    <span>{{ cart.total }} {{ data.currency }}</span>
                  </div>
                  <div class="summary__item">
                    <span>Odbiór</span>
                    <span>online, natychmiast</span>
                  </div>
                  <a :href="links.checkout_url" class="button button--green summary__button">
                    Przejdź do płatności
                  </a>
                </div>
              </div>
            </template>
            <template v-else>
              <p class="content section__content__empty">Koszyk jest pusty. <a :href="`${links.shop_url}?tab=2`">Przejdź do ofert</a></p>
            </template>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {mapFields} from "vuex-map-fields";

export default {
  props: {
    data: {
      type: Object,
      required: true,
    },
    links: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      couponValue: '',
      couponErrorText: null
    }
  },
  created() {
    this.$store.commit('setCart', this.data)
  },
  computed: {
    ...mapFields([
      'cart',
    ])
  },
  methods: {
    async setCount(value, trigger, product) {
      if (value < 1) {
        return
      }

      let quantity

      if (trigger) quantity = value
      else quantity = value

      await this.$store.dispatch('AJAX_SET_QUANTITY', {
        key: product.key,
        quantity,
      })
    },
    async addCouponCode() {
      const res = await this.$store.dispatch('AJAX_ADD_COUPON_CODE', {coupon: this.couponValue})

      if (res.success) {
        this.couponErrorText = null
      } else {
        this.couponErrorText = res.data
      }
    }
  }
}
</script>
